# SPDX-FileCopyrightText: Copyright (c) 2023, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2022-2023 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT

Image-Build-{{ CI_JOB_NAME_SLUG }}:
  tags:
{%- if FORCE_BUILD_HOST_ARCH is defined %}
    - {{ FORCE_BUILD_HOST_ARCH }}
{%- else %}
    - {{ BUILD_HOST_ARCH }}
{%- endif %}
  extends: .kas_build_cassini
  # Store the build artifacts from the job. The download urls of these artifacts are later used by lava jobs to download and test the image.
  variables:
    KAS_CONFIGS: "{{ CI_JOB_NAME }}"
  after_script:
    # Store build output data for test stages
    - pushd ${KAS_WORK_DIR}/build/tmp/deploy/images/{{ MACHINE }}
{%- if MACHINE.startswith('corstone1000') %}
    - export IMAGE=$(ls -- *-{{ MACHINE }}.wic.bmap | sed "s/-{{ MACHINE }}\.wic\.bmap//")
    - ROOTFS_IMAGE="${IMAGE}-{{ MACHINE }}.wic"
{%- else %}
    - export IMAGE=$(ls -- *-{{ MACHINE }}.rootfs.wic.bmap | sed "s/-{{ MACHINE }}\.rootfs\.wic\.bmap//")
    - ROOTFS_IMAGE="${IMAGE}-{{ MACHINE }}.rootfs.wic"
{%- endif %}
    - echo "IMAGE=${IMAGE}" > ${CI_PROJECT_DIR}/build_data.env
    - echo "IMAGE = ${IMAGE}"
    - export ARTIFACT_DIR="$(realpath --relative-to=${CI_PROJECT_DIR} ${KAS_WORK_DIR})/build/tmp/deploy/images/{{ MACHINE }}"
    - echo "ARTIFACT_DIR=${ARTIFACT_DIR}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "ARTIFACT_DIR = ${ARTIFACT_DIR}"
    - echo "IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${ROOTFS_IMAGE}.gz)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "BMAP_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${ROOTFS_IMAGE}.bmap)" >> ${CI_PROJECT_DIR}/build_data.env
{%- if MACHINE == 'n1sdp' %}
    - export FW_IMAGE=$(ls -- *-board-firmware_primary.tar.gz | sed "s/-board-firmware_primary\.tar\.gz//")
    - echo "FW_IMAGE=${FW_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
{%- elif MACHINE.startswith('corstone1000') %}
    - echo "BL1_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/bl1.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "BL1_IMAGE=bl1.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - |
      export UTIL_IMAGE=$(ls -- *-{{ MACHINE }}.tar.bz2 | sed "s/-{{ MACHINE }}\.tar\.bz2//")
      if [ -e ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2 ]; then
        echo "UTIL_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2)" >> ${CI_PROJECT_DIR}/build_data.env
        echo "UTIL_IMAGE=${UTIL_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
      fi
    - export FW_IMAGE=$(ls -- corstone1000-image-{{ MACHINE }}.wic | sed "s/-{{ MACHINE }}\.wic//")
    - echo "FW_IMAGE=${FW_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "FW_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${FW_IMAGE}-{{ MACHINE }}.wic)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "EXTSYS_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/es_flashfw.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "EXTSYS_IMAGE=es_flashfw.bin" >> ${CI_PROJECT_DIR}/build_data.env
{%- if MACHINE == 'corstone1000-fvp' %}
    - export FVP_CONFIG=$(ls -- *-{{ MACHINE }}.fvpconf | sed "s/-{{ MACHINE }}\.fvpconf//")
    - echo "FVP_CONFIG_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/work/build/tmp/deploy/images/{{ MACHINE }}/$(readlink ${FVP_CONFIG}-{{ MACHINE }}.fvpconf)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "FVP_CONFIG=${FVP_CONFIG}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${IMAGE}-{{ MACHINE }}.wic.pad.gz)" >> ${CI_PROJECT_DIR}/build_data.env
{%- endif %}
{%- endif %}
    - chmod 777 ${CI_PROJECT_DIR}/build_data.env
    - cat ${CI_PROJECT_DIR}/build_data.env
    # Store built images
    - |
      (
        flock --timeout 120 200
        rm -rf ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}
        mkdir --parents ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}
        cp $(readlink ${ROOTFS_IMAGE}.gz) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${ROOTFS_IMAGE}.gz
        cp $(readlink ${ROOTFS_IMAGE}.bmap) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${ROOTFS_IMAGE}.bmap
{%- if MACHINE == 'n1sdp' %}
        cp ${FW_IMAGE}-board-firmware_primary.tar.gz ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FW_IMAGE}-board-firmware_primary.tar.gz
{%- elif MACHINE.startswith('corstone1000') %}
        cp bl1.bin ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/bl1.bin
        cp es_flashfw.bin ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/es_flashfw.bin
        cp $(readlink ${FW_IMAGE}-{{ MACHINE }}.wic) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FW_IMAGE}-{{ MACHINE }}.wic
        if [ -e ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2 ]; then
          cp $(readlink ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2
        fi
{%- if MACHINE == 'corstone1000-fvp' %}
        cp $(readlink ${FVP_CONFIG}-{{ MACHINE }}.fvpconf) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FVP_CONFIG}-{{ MACHINE }}.fvpconf
        cp $(readlink ${IMAGE}-{{ MACHINE }}.wic.pad.gz) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${IMAGE}-{{ MACHINE }}.wic.pad.gz
{%- endif %}
{%- endif %}
      ) 200>${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}.lock
    - popd # ${KAS_WORK_DIR}/build/tmp/deploy/images/{{ MACHINE }}
  artifacts:
    paths:
{%- if MACHINE != 'corstone1000-fvp' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.gz
{%- endif %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.bmap
{%- if MACHINE == 'n1sdp' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-board-firmware_primary.tar.gz
{%- elif MACHINE.startswith('corstone1000') %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/bl1.bin
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/es_flashfw.bin
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/corstone1000-image-*.wic
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/corstone1000-utils-overlay-*.tar.bz2
{%- if MACHINE == 'corstone1000-fvp' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.fvpconf
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.pad.gz
{%- endif %}
{%- elif MACHINE == 'zynqmp-kria-starter' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/ImageA.bin
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/ImageB.bin
{%- endif %}
      - build_data.env
    reports:
      dotenv: build_data.env
    expire_in: '1 days'
  # Shouldn't interrupt a build or the DL_DIR can become corrupt
  interruptible: false

# What platforms exist in the Lava test farm
{%- set platform_list = (LAVA_PLATFORMS + ',' + TUXSUITE_PLATFORMS).split(',') | map('trim') | reject('==', '') | list -%}
# This variable lists the tests that we provide lava test definitions for testing the built image
{%- set supported_test_list = SUPPORTED_TESTS.split(',') | map('trim') | reject('==', '') | list -%}
# This lists the tests that a manual or scheduled test run irrespective of if it would normally
# be run for this image/build
{%- set force_test_list = FORCE_TESTS.split(',') | map('trim') | reject('==', '') | list -%}

# The should_run variable should be true if the test should be run during this build and can be
# used to limit what tests are run for each build/pipeline run type.

{% if supported_test_list and 'none' not in supported_test_list and MACHINE in platform_list %}
Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}:
  extends: .test-preparation
  needs:
    - Image-Build-{{ CI_JOB_NAME_SLUG }}
  variables:
    MACHINE: "{{ MACHINE }}"

{% set can_run = ('all' in supported_test_list or 'ptest' in supported_test_list) -%}
{%- set force =  ('all' in force_test_list or 'ptest' in force_test_list) -%}
{%- set should_run = (MACHINE != "corstone1000-mps3" or (CI_PIPELINE_SOURCE == "schedule" and MACHINE == "corstone1000-mps3")) -%}
{%- if can_run and (should_run or force) %}
PTest-{{ CI_JOB_NAME_SLUG }}:
  extends: .ptest-tests
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{%- if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{%- endif %}
  variables:
    MACHINE: "{{ MACHINE }}"

PTest-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .ptest-tests-results
  needs:
    - PTest-{{ CI_JOB_NAME_SLUG }}
  variables:
    MACHINE: "{{ MACHINE }}"
{% endif %}

{% set can_run = ('all' in supported_test_list or 'sanity' in supported_test_list) -%}
{%- set force = ('all' in force_test_list or 'sanity' in force_test_list) -%}
{%- set should_run = (MACHINE != "corstone1000-mps3" or (CI_PIPELINE_SOURCE == "schedule" and MACHINE == "corstone1000-mps3")) -%}
{%- if can_run and (should_run or force) %}
Sanity-Test-{{ CI_JOB_NAME_SLUG }}:
  extends: .sanity-test
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{%- if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{%- endif %}
  variables:
    MACHINE: "{{ MACHINE }}"

Sanity-Test-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .sanity-test-results
  needs:
    - Sanity-Test-{{ CI_JOB_NAME_SLUG }}
  variables:
    MACHINE: "{{ MACHINE }}"
{% endif %}

{% set can_run = ('all' in supported_test_list or 'acs' in supported_test_list) -%}
{%- set force =  ('all' in force_test_list or 'acs' in force_test_list) -%}
{%- set should_run = (CI_PIPELINE_SOURCE == "schedule" and MACHINE!="corstone1000-mps3" ) -%}
{%- if can_run and (should_run or force) -%}
{%- for i in range(NUMBER_OF_SEQUENCE_FILES | int) %}
ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}:
  extends: .acs-test
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{%- if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{%- endif %}
  variables:
    MACHINE: "{{ MACHINE }}"
    SEQUENCE_FILE_PREFIX: "EBBR"
    SEQUENCE_FILE_NUMBER: "{{ i + 1 }}"
    TOTAL_SEQUENCE_FILES: "{{ NUMBER_OF_SEQUENCE_FILES }}"

ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .acs-test-results
  needs:
    - ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}
  variables:
    SEQUENCE_FILE: "EBBR{{ i + 1 }}"
    MACHINE: "{{ MACHINE }}"
{% endfor %}
{%- endif %}

{%- endif %}
